require("player")

event.waitInput = function()
	local yield = coroutine.yield
	yield()
	while not (input.tapped(input.A) or input.pressed(input.Y)) do
		yield()
	end
end

Dialog = {
	routine = function(self)
		local margin = {x = 8, y = 8}
		local height = screen.h * 0.125
		local dy = (margin.y + height) / 20
		local yield = coroutine.yield

		self.group = Object.NONE
		self.frame.x = margin.x
		self.frame.y = screen.h
		self.frame.w = screen.w - margin.x * 2
		self.frame.h = height

		player.canShotBullet = false

		yield()
		for i = 1, 20 do
			self.position.y = self.position.y - dy
			yield()
		end

		while not self.finished do yield() end

		self.string = ""
		self.left = nil
		self.right = nil

		for i = 1, 20 do
			self.position.y = self.position.y + dy
			yield()
		end
		
		player.canShotBullet = true
		self:delete()
	end;

	draw = function(self)
		if self.left then self.left:drawAt(vector.new(140, 300)) end
		if self.right then self.right:drawAt(vector.new(screen.w - 140, 300)) end
		graphics.window:drawAt(self.position)
		if self.string then graphics.drawStringInBox(self.string, self.frame) end
	end;
	
	leftSays = function(self, string)
		self.left.brightness = nil
		if self.right then self.right.brightness = {r = 100, g = 100, b = 100} end
		self.string = string
	end;
	
	rightSays = function(self, string)
		self.right.brightness = nil
		if self.left then self.left.brightness = {r = 100, g = 100, b = 100} end
		self.string = string
	end;
}

setmetatable(Dialog, {__index = Object})
