EBird = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.group = Object.ENEMY
		self.score = 100
	end;
	draw = function(self)
		graphics.thisstage.bird:drawAt(self.position)
	end;
}
EBirdCross = {
	routine = function(self)
		wait(self.delay)
		self:move(160)
		nwayBToPlayer(self.position,size.spindle,4,9,8,0,graphics.spindle[3])
		self:accelerate(1)
		if self.position.y>screen.h/2 then
			self:bend(80,120)
		else
			self:bend(-80,120)
		end
		self:move(-1)
	end;
}

------------------------------------------------------------------------------------------
EBirdSlow = {
	routine = function(self)
		wait(self.delay)
		self:move(30)
		self:accelerateGradually(-4.5, 30)
		local bullets = nwayBToPlayer(self.position, size.ballL, 4.6, 37, 360/37, 0,graphics.ballL[7])
		bullets.routine = function(self)
			wait(20)
			self:accelerateGradually(-1, 60)
			wait(1000)
		end
		self:move(60)
		self:accelerate(2)
		if self.position.y>screen.h/2 then
			self:bend(-60,30)
		else
			self:bend(60,30)
		end
		self:move(-1)
	end;
}

------------------------------------------------------------------------------------------
EBirdSin = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.group = Object.ENEMY
		self.score = 190
	end;
	routine = function(self)
		wait(self.delay)
		local a = 1
		while true do
			for i=1,18 do
				nwayBDirSpeed(self.position, size.ballL, 150,5,3,10,10,graphics.ballL[4])
				self:move(4)
			end
			if a==1 then
				nwayBToPlayer(self.position,size.spindle,5,11,5,8,graphics.spindle[7])
				end
			a = a*(-1)	
		end
	end;
	move = function(self, frame)
		local yield = coroutine.yield
		if frame==-1 then
			while true do
				self.velocity = vector.new(-8, cosPatternC())
				self.position = self.position + self.velocity
				yield()
			end
		end
		for i=1,frame do
			self.velocity = vector.new(-8, cosPatternC())
			self.position = self.position + self.velocity
			yield()
		end
	end;
}

------------------------------------------------------------------------------------------
EBirdWall = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.group = Object.ENEMY
		self.score = 160
	end;
	routine = function(self)
		wait(self.delay)
		self:move(95)
		wait(30)
		self.velocity = vector.new(-7,0)
		for i = 1,2 do
			self:move(7)
			nwayBDirSpeed(self.position, size.spindle, 180, 4.5, 8, 10, 0,graphics.spindle[7])
			self:move(35)
		end
		self:move(-1)
	end;
}

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
ESun = {
	initialize = function(self)
		self.frame.w = 80
		self.frame.h = 80
		self.hp = 7
		self.itime = 0
		self.itime_init = 120
		self.group = Object.ENEMY
		self.score = 590
		self.graphic = graphics.thisstage.sun
	end;
	routine = function(self)
		self.followers = nwayDirSpeed(self.position, 0, 155, 10, 36, 0, ESunLight)
		self.followers.routine = function(self)
			self:move(1)
			self:accelerate(-150)
			self:rotate(90)
			self:bend(20000,10000)
		end
		self:bend(135,100)
		self:accelerateGradually(-7, 100)

		local sign=1
		for i=1,2 do
			self.velocity = vector.new(-1.5, 0)
			self:bend(sign*150,120)
			nwayBToPlayer(self.position, vector.new(15,15), 5,7,10,10,graphics.thisstage.fire)
			self:rotate(sign*30)
			self:move(30)
			nwayBToPlayer(self.position, vector.new(15,15), 5,7,10,10,graphics.thisstage.fire)
			self:accelerate(-10)
			self:move(60)
			self.velocity = vector.new(0, sign*1)
			self:move(100)
			nwayBToPlayer(self.position, vector.new(15,15), 5,7,10,10,graphics.thisstage.fire)
			self:accelerate(-5)
			self:move(120)
			nwayBToPlayer(self.position, vector.new(15,15), 5,7,10,10,graphics.thisstage.fire)
			sign = sign * -1
		end
		self:move(600)
		self:remove()
	end;
}

------------------------------------------------------------------------------------------
ESunLight = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.itime = 0
		self.group = Object.ENEMY_SHIELD
		self.score = 0
	end;
	routine = function(self)
		wait(self.delay)
		self:move(200)
		for i=1,5 do
			nwayBToPlayer(self.position, vector.new(15,15), 3,7,10,20,graphics.thisstage.fire)
			self:move(100)
			nwayBToPlayer(self.position, vector.new(15,15), 3,5,15,20,graphics.thisstage.fire)
			self:move(100)
		end
		self:move(-1)
	end;
	draw = function(self)
		if self.itime%6 > 0 then return end
		graphics.thisstage.fireball:drawAt(self.position)
	end;
	move = function(self, frame)
		local yield = coroutine.yield
		if frame ==-1 then
			while true do
				self.position = self.position + self.velocity
				self.group = Object.ENEMY_SHIELD
				if self.itime>0 then
					self.itime = self.itime - 1
					self.group = Object.ENEMY
				end
				yield()
			end
		end
		for i=1,frame do
			self.position = self.position + self.velocity
			self.group = Object.ENEMY_SHIELD
			if self.itime>0 then
				self.itime = self.itime - 1
				self.group = Object.ENEMY
			end
			yield()
		end
		return self
	end;
	hit = function(self, obj)
		if self.itime>0 then return end
		if obj.group == Object.PLAYER_BULLET then
			self.itime = 300
		end
		if obj.group == Object.PLAYER then
			player.position = player.position + 15*self.velocity
			self.itime = 300
		end
	end;
}
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
ESizune = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 80
		self.itime = 0
		self.group = Object.ENEMY_SHIELD
		self.score = 0
	end;
	routine = function(self)
		self.followers = nwayDirSpeed(self.position+vector.new(0,120),180,5,1,90,0,EBossEye)
		self.followers.routine = function(self) self:bend(30000,12560) end
		self:accelerateGradually(-2,150)
		repeat self:levitate(1) until bossbattle_start
---[[
		--1000frame
		for i=0,4 do
			nwayBToPlayer(self.position,size.ballL,83,33,360/33,30*i,graphics.ballL[3]):rotate(10*(3-i)):move(1):accelerate(-80)
		end
		self:pause(130)

		self:setMovePosition02(vector.new(screen.w-150, screen.h/2), 100)
		self:pause(100)
		--ǒe1000frame
		for i = 1,3 do
			nwallTarget(vector.new(screen.w,screen.h/2), vector.new(screen.w/2,screen.h/2),2 , 4+i, 50 , 0, EBirdWall)
			self:levitate(1)
		end
		self:levitate(2)
		--J[ee1200frame
		for i=1,7 do
			createShot(vector.new(screen.w+30, math.random(50, screen.h-100)), vector.new(0,0), 0, EBirdSin)
			self:pause(100)
			nwayBToPlayer(self.position,size.spindle,5,11,5,0,graphics.spindleGloss[2])
			self:pause(100)
		end
--]]
---[[
		--1600frame
		for i=1,5 do
			nwayBDirSpeed(vector.new(self.position.x-60,self.position.y), size.ballL, 150+11*i, 5, 15, 180/15, 0,graphics.ballL[3])
			self:pause(20)
		end
--]]
---[[
		--650frame
		self.velocity = vector.new(-1, 2)
		self:accelerateGradually(2, 10)
		for i=1,3 do
			nwayBToPlayer(self.position, size.spindle,84, 19, 360/19, 0, graphics.spindle[9]):rotate(-20*(2-i)):move(1):accelerate(-80)
			self:bend(10, 20)
		end
		self:accelerate(-5)
		self:pause(80)

		self.velocity = vector.new(0,-2.5)
		for i=1,5 do
			nwayBDirSpeed(vector.new(self.position.x-60,self.position.y), size.arrowhead,150+10*i, 4, 9, 12, 0,graphics.arrowhead[6])
			self:move(30)
		end
		self:pause(60)
	
		self.velocity = vector.new(0.5, 1)
		self:accelerateGradually(2, 10)
		for i=1,3 do
			nwayBToPlayer(self.position,size.spindle,84,19,360/19,0,graphics.spindle[9]):rotate(-20*(2-i)):move(1):accelerate(-80)
			self:move(20)
		end
		self:accelerate(-100)
		self:move(200)
--]]		
		local a = 1
		for i=1,20 do
			for j=1,6 do
				nwayBDirSpeed(self.position,size.ballL,15*j*a,48.5,9,360/9,0,graphics.ballL[7]):move(1):accelerate(-45)
				self:move(10)
			end;
			a = a * (-1)
		end
		self:pause(30)
		self.velocity = vector.new(0.7,1.5):lengthen(2.5)
		self:move(50)
		self.velocity = vector.new(0,1.5):lengthen(2.5)
		self:bend(180,70)
		self:pause(50)
		self.velocity = vector.new(0.7,-1.5):lengthen(2.5)
		self:move(100)
		self:pause(70)
		self.velocity = vector.new(0,-1.5):lengthen(2.5)
		self:bend(-150,70)
		self:move(60)
		self:pause(65)
		self.velocity = vector.new(0,-2):lengthen(3)
		self:bend(720,500)
		self.velocity = vector.new(3,0)
		self:pause(50)
		self:move(55)
		self:pause(80)
		self:levitate(2)
		self.velocity = vector.new(0,0)
		for j=1,5 do
			for i=1,18 do
				nwayBToPlayer(self.position, size.ballL, 59, 5, 8, 0, graphics.ballL[2]):rotate(i*(4+(-1)^j)*j):move(1):accelerate(-55)
				nwayBToPlayer(self.position, size.ballL, 59, 5, 8, 0, graphics.ballL[2]):rotate(-i*(4+(-1)^j)*j):move(1):accelerate(-55)
				self:pause(8)
			end
		end
---[[
		--900frame
		local updown = 1
		for j=1,6 do
			for i=0,19 do
				local b = createBullet(vector.new(850, i*30-15), vector.new(-1,0):rotate(updown*25), size.block, 0, graphics.block[2])
				b.draw = function(self) self.graphic:drawAt(self.position) end
				b.move = function(self, frame)
					local yield = coroutine.yield
					if frame ==-1 then
						while true do
							if self.position.y > screen.h+32 then
								self.position.y = -32
							end
							if self.position.y < -32 then
								self.position.y = screen.h+32
							end
							self.position = self.position + self.velocity
							yield()
						end
					end
					for i=1,frame do
						if self.position.y > screen.h+32 then
							self.position.y = -32
						end
						if self.position.y < -32 then
							self.position.y = screen.h+32
						end
						self.position = self.position + self.velocity
						yield()
					end
				end
			end
			self:levitate(1)
			updown = updown * -1
		end
--]]
		self.velocity = vector.new(0.5,2)
		self:move(600)
	end;
}

------------------------------------------------------------------------------------------

EBossEye = {
	initialize = function(self)
		self.frame.w = 40
		self.frame.h = 40
		self.itime = 0
		self.itime_init = 120
		self.group = Object.ENEMY_SHIELD
		self.score = 200
	end;
	routine = function(self)
		repeat self:move(200) until bossbattle_start
		self:move(3425)
		for i=1,25 do
			nwayBToPlayer(self.position,size.spindle,4,3,5,0,graphics.spindleGloss[2])
			self:move(50)
		end
		self:move(230)
		for i=1,31 do
			self:move(45)
			nwayBDirSpeed(self.position, size.ballL, 0, 3, 19, 360/19, 0, graphics.ballL[8]):rotate(50*i)
			nwayBToPlayer(self.position, size.ballL, 4, 23, 360/23, 15,graphics.ballL[7])
		end;
		self:move(250)
		for i=1,20 do
			nwayBToPlayer(self.position,size.spindle,4,5,7,0,graphics.spindle[2])
			self:move(50)
		end
		self:move(10000)
	end;
	draw = function(self)
		if self.itime%6 > 0 then return end
		local v = (player.position - self.position):rotate(45)
		local q = quadrant(v, vector.new(0,0))
		if q==1 then
			graphics.eye[4]:drawAt(self.position)
		elseif q==2 then
			graphics.eye[2]:drawAt(self.position)
		elseif q==3 then
			graphics.eye[5]:drawAt(self.position)
		else
			graphics.eye[3]:drawAt(self.position)
		end
	end;
}



setmetatable(EBird,		{__index = Enemy})
setmetatable(EBirdCross,{__index = EBird})
setmetatable(EBirdSlow,	{__index = EBird})
setmetatable(EBirdSin,	{__index = EBird})
setmetatable(EBirdWall,	{__index = EBird})
setmetatable(ESun,		{__index = EDFollowedHP})
setmetatable(ESunLight,	{__index = Enemy})
setmetatable(ESizune,	{__index = Sizune})
setmetatable(EBossEye,	{__index = EDurable})

