EShell = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.group = Object.NONE		
	end;
	routine = function(self)
		while true do
			self:move(120)
			nwayDirSpeed(self.position,270,3,7,20,0,EBubble)
		end
	end;
}
EBubble = {
	initialize = function(self)
		self.frame.w = 20
		self.frame.h = 20
		self.graphic = graphics.thisstage.bubble[1]
		self.group = Object.ENEMY		
	end;
	routine = function(self)
		self:move(40)
		self.velocity = vector.new(0,-math.random(150,200)/100)
		self:move(40)
		for i = 1,3 do
			if math.random(1,100) > 90 then self:delete() end
			self.velocity = self.velocity + vector.new(0, 0.25)
			self.frame.w =20 + i*10
			self.frame.h =20 + i*10
			self.graphic = graphics.thisstage.bubble[i+1]
			self:move(100)
		end
		self:move(-1)
	end;
	draw = function(self)
		self.graphic:drawAt(self.position)
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER_BULLET or obj.group == Object.PLAYER then
			sound.bubble:play()
			self:delete()
		end
	end;
}
EFish = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 15
		self.score = 80
		self.group = Object.ENEMY		
	end;
	draw = function(self)
		if self.velocity.x>0 then
			graphics.thisstage.fishR:drawRotatedAt(self.position, math.atan2(self.velocity.y, self.velocity.x))
		else
			graphics.thisstage.fishL:drawRotatedAt(self.position, math.atan2(-self.velocity.y, -self.velocity.x))
		end
	end;
}
EFishSlow = {
	routine = function(self)
		wait(self.delay)
		self:move(math.random(100,300))
		self:gather(player.position, 5)
		self:move(-1)
	end;
}
EFishFast = {
	routine = function(self)
		wait(self.delay)
		self:move(20)
		self:accelerateGradually(-3,20)
		nwayBToPlayer(self.position, size.spindle, 4, 5, 10, 0,graphics.spindle[2])
		self:accelerateGradually(-6,20)
		for i=1,7 do
			nwayBToPlayer(self.position,size.ballL, 3, 1, 6, 0, graphics.ballL[3])
			self:move(150)
		end
		self:move(-1)
	end;
}
EDarknessParent = {
	initialize = function(self)
		self.frame.w = 0
		self.frame.h = 0
		self.score = 0
		self.group = Object.NONE
	end;
	routine = function(self)
		for j=1,62 do
			for i = 1,10 do
				local b = createBullet(vector.new(screen.w+50,math.random(-30,screen.h+30)),vector.new(-1,0),vector.new(50,50), 0, graphics.thisstage.darkness)
				b.hit = function(self) self:delete() end
			end
			wait(30)
		end
	end;
}
EAnglar = {
	initialize = function(self)
		self.frame.w = 70
		self.frame.h = 70
		self.score = 1000
		self.hp = 12
		self.itime = 0
		self.itime_init = 120
		self.cosPattern = cosPattern(1.5, 0.6)
		self.group = Object.PLAYER_BULLET
	end;
	routine = function(self)
		self:sinMove(0.6, 1500)

		self.frame.w = 55
		self.frame.h = 55
		self.group = Object.ENEMY
		self.draw = function(self)
			if self.itime%6 > 3 then return end
			if self.velocity.x>0 then
				graphics.thisstage.anglarR:drawAt(self.position)
			else
				graphics.thisstage.anglarL:drawAt(self.position)
			end
		end
---[[
		for i=1,17 do
			nwayBDirSpeed(self.position, size.spindle,i,9,12,30,0,graphics.spindle[3])
			self:sinMove(0, 30)
		end
--]]
		self:setMovePosition02(vector.new(800, screen.h/2), 200)
		self:pause(60)
		self.cosPattern = cosPattern(0.5, 0.6)
---[[
		for j=1,10 do
			local b = nwayBDirSpeed(self.position,size.ballM,math.random(0,180),3,18,20,0,graphics.ballM[7])
			b.routine = function(self)
				wait(20)
				self:bend(-90, 1)
				for i=1,100 do self:bend(-5, i) end
				wait(-1)
			end
			b = nwayBDirSpeed(self.position,size.ballM,math.random(0,180),3,18,20,0,graphics.ballM[8])
			b.routine = function(self)
				wait(20)
				self:bend(90, 1)
				for i=1,100 do self:bend(5, i) end
				wait(-1)
			end
			self:sinMove(0 ,100)
		end
--]]
		self:pause(10)
		self:sinMove(1, 100)
		self.cosPattern = cosPattern(2.3, 0.6)
		for i=1,30 do
			nwayBDirSpeed(self.position,size.ballM,-40,1,9,20,0,graphics.ballM[1]):rotate(-i):accelerate(0.1*i)
			self:sinMove(-3, 10)
		end
		self.velocity = vector.new(0.1, 0)
		self:move(30)
		self:vectorMove(vector.new(1, 0.4), 30)
		self:move(60)
		for i=1,30 do
			nwayBDirSpeed(self.position,size.ballM,120,1,9,20,0,graphics.ballM[1]):accelerate(0.1*i)
			self:sinMove(3, 10)
		end
		self:move(-1)
	end;
	draw = function(self)
		graphics.thisstage.lightness:drawAt(self.position)
	end;
	sinMove = function(self, vx, frame)
		for i=1,frame do
			self.velocity = vector.new(vx, self.cosPattern())
			self:move(1)
		end
		return self
	end;
}

EMermaid = {
	draw = function(self)
--		graphics.drawLineBox(self.frame, 255,255,255)
		if self.velocity.y<0 then
			graphics.thisstage.mermaid:drawAt(self.position)
		else
			graphics.thisstage.mermaid:drawRotatedAt(self.position, 3.14)
		end
	end;
}
EMermaidTrail = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 80
		self.score = 100
		self.bullets = Group.new()
		self.cosPattern = cosPattern(10,120)
		self.group = Object.ENEMY
	end;
	routine = function(self)
		for i=1,14 do
			self.bullets:add(createBullet(vector.new(self.position.x+self.cosPattern(),self.position.y), vector.new(0,0), size.ballS, 0, graphics.ballS[4]))
			self:move(10)
		end
		self.bullets:gather(player.position, 2)
		self:move(-1)
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER_BULLET then
			createShot(self.position, vector.new(0,0), 0, Explosion)
			self.bullets:gather(player.position, 1)
			self:dropItem()
			self:delete()
		elseif obj.group == Object.PLAYER then
			self.bullets:gather(player.position, 1)
			self:delete()
		end
	end;
}
EMermaidWake = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 80
		self.score = 100
		self.itime = 0
		self.group = Object.ENEMY
	end;
	routine = function(self)
		for i=1,10 do
			self:move(20)
			nwayB(self.position, -self.velocity:lengthen(2), size.ballM, 2, 140, 0, graphics.ballM[7])
		end
		self:move(-1)
	end;
}
EMermaidPincer = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 80
		self.score = 80
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self:move(50)
		for i =1,2 do
			nwayBToPlayer(self.position,size.ballM,2,4,10,0,graphics.ballM[6])
			nwayBToPlayer(self.position,size.ballM,7/3,3,20,0,graphics.ballM[7])
			nwayBToPlayer(self.position,size.ballM,8/3,4,15,0,graphics.ballM[8])
			wait(100)
		end
		if self.position.y>screen.h/2 then
			self.velocity = vector.new(0, 1)
		else
			self.velocity = vector.new(0, -1)
		end
		self:move(-1)
	end;
}
ESizune = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 80
		self.itime = 0
		self.group = Object.ENEMY_SHIELD
	end;
	routine = function(self)
		self.followers = nwayDirSpeed(self.position+vector.new(0,120),180,5,1,90,0,EBossEye)
		self.followers.routine = function(self) self:bend(30000,12560) end
		self:accelerateGradually(-2,150)
		repeat self:levitate(1) until bossbattle_start
---[[
		for i=1,3 do
			self:levitate(1)
			createShot(vector.new(player.position.x+250*(-1)^i,0),vector.new(0,4),0,EMermaidTrail)
			createShot(vector.new(player.position.x-250*(-1)^i,screen.h),vector.new(0,-4),0,EMermaidTrail)
			self:levitate(1)
			createShot(vector.new(player.position.x-150*(-1)^i,screen.h),vector.new(0,-5),0,EMermaidWake)
			createShot(vector.new(player.position.x+150*(-1)^i,0),vector.new(0,5),0,EMermaidWake)
			self:levitate(1)
			createShot(vector.new(player.position.x+50*i,0),vector.new(0,1),0,EMermaidPincer)
			createShot(vector.new(player.position.x+50*i,screen.h+20),vector.new(0,-1),0,EMermaidPincer)
			self:levitate(1)
		end
--]]
---[[
		self:levitate(2)
		createSpiralParent(vector.new(screen.w+50, 150), vector.new(-10, 0), 20, 0, -1)
		createSpiralParent(vector.new(screen.w+50, screen.h-150), vector.new(-10, 0), 20, 0, 1)
		wait(400)
		for i=1,5 do
			nwayBDirSpeed(self.position, vector.new(10,10), 180, 5, 5, 10, 0, graphics.spindle[5])
			wait(6)
		end
		self.velocity = vector.new(-0.5,-1)
		self:accelebend(-70, 1.5, 180)
		self:bend(-40, 120)
		self:accelerate(-5)

		createSpiralParent(vector.new(-50, 150), vector.new(10, 0), 20, 0, 1)
		createSpiralParent(vector.new(-50, screen.h-150), vector.new(10, 0), 20, 0, -1)

		self:levitate(1)
		for i=1,5 do
			local b = nwayBDirSpeed(self.position, size.ballL, -8*i, 4, 10, 36, 0, graphics.ballL[7])
			b.routine = function(self) self:move(10):accelerate(-3):move(-1) end
			self:pause(30)
		end
		self.velocity = vector.new(0.5, 1)
		self:accelebend(-70, 1.5, 180)
		self:bend(-40, 120)
		self:accelerate(-5)
		self:levitate(2)

		createSpiralParent(vector.new(screen.w+50, 150), vector.new(-10, 0), 20, 0, -1)
		createSpiralParent(vector.new(screen.w+50, screen.h-150), vector.new(-10, 0), 20, 0, 1)
		self:levitate(3)
--]]
		createShot(self.position, vector.new(-3,-0.5), 90, EWaveParent)
		self:setMovePosition02(vector.new(screen.w+50,screen.h+50), 300)
	end;
}

EBossEye = {
	initialize = function(self)
		self.frame.w = 40
		self.frame.h = 40
		self.score = 200
		self.itime = 0
		self.itime_init = 120
		self.group = Object.ENEMY_SHIELD
	end;
	routine = function(self)
		repeat self:move(200) until bossbattle_start
		self:move(-1)
	end;
	draw = function(self)
		if self.itime%6 > 0 then return end
		local v = (player.position - self.position):rotate(45)
		local q = quadrant(v, vector.new(0,0))
		if q==1 then
			graphics.eye[4]:drawAt(self.position)
		elseif q==2 then
			graphics.eye[2]:drawAt(self.position)
		elseif q==3 then
			graphics.eye[5]:drawAt(self.position)
		else
			graphics.eye[3]:drawAt(self.position)
		end
	end;
}

--turn = 1,-1
--phase difference[0,60]
function createSpiral(position, turn, pd)
	local a = createShot(position, vector.new(0,0), 0, ESpiral)
	a.turn = turn
	a.pd = pd
	return a
end
function createSpiralParent(position, velocity, span, delay, turn)
	local a = createShot(position, velocity, 0, ESpiralParent)
	a.turn = turn
	a.span = span
	a.delay = delay
	return a
end

ESpiralParent = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 15
		self.score = 100
		self.hp = 1
		self.itime = 0
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self:move(self.delay)
		for i=1,4 do
			self:move(self.span)
			createSpiral(self.position, self.turn, 80*(i-1))
		end
		self:move(-1)
	end;
	draw = function(self)
		if self.velocity.x>0 then
			graphics.thisstage.fishR:drawRotatedAt(self.position, math.atan2(self.velocity.y, self.velocity.x))
		else
			graphics.thisstage.fishL:drawRotatedAt(self.position, math.atan2(-self.velocity.y, -self.velocity.x))
		end
	end;
}
ESpiral = {
	initialize = function(self)
		self.frame.w = 3
		self.frame.h = 3
		self.score = 100
		self.group = Object.NONE
	end;
	routine = function(self)
		for i=1,50 do
			nwayDirSpeed(self.position, self.turn*(i+self.pd)*7, 3, 3, 120, 0, ESpiralBullet)
			wait(10)
		end
	end;
	draw = function(self)
		graphics.drawLineBox(self.frame, 255, 255, 255);
	end;
}
ESpiralBullet = {
	initialize = function(self)
		self.frame.w = size.spindle.x
		self.frame.h = size.spindle.y
		self.graphic = graphics.spindle[2]
		self.score = 10
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self:move(70)
	end;
}

EWaveParent = {
	initialize = function(self)
		self.frame.w = 3
		self.frame.h = 3
		self.group = Object.NONE
	end;
	routine = function(self)
		wait(30)
		self:setMovePosition02(vector.new(screen.w/2, screen.h/2), 100)
		for i=1,20 do
			local b = nwayBDirSpeed(self.position, size.ballL, 7*i, 7, 20, 18, 0, graphics.ballL[2])
			b.routine = function(self) while true do self:move(10):accelerate(-3) end end
			self:pause(20)
		end
	end;
	draw = function(self)
		graphics.drawLineBox(self.frame, 255,255,255)
	end;
}

--------------------------------------------------------
--------------------------------------------------------
setmetatable(EShell,		{__index = Enemy})
setmetatable(EBubble,		{__index = Enemy})
setmetatable(EFish,		{__index = Enemy})
setmetatable(EFishFast,		{__index = EFish})
setmetatable(EFishSlow,		{__index = EFish})
setmetatable(EDarknessParent,	{__index = Enemy})
setmetatable(EAnglar,		{__index = EDurableHP})
setmetatable(EMermaid,		{__index = Enemy})
setmetatable(EMermaidTrail,		{__index = EMermaid})
setmetatable(EMermaidWake,		{__index = EMermaid})
setmetatable(EMermaidPincer,	{__index = EMermaid})
setmetatable(ESizune,	{__index = Sizune})
setmetatable(EBossEye,	{__index = EDurable})
setmetatable(ESpiralParent,	{__index = EDurableHP})
setmetatable(ESpiral,	{__index = Enemy})
setmetatable(ESpiralBullet,	{__index = EBullet})
setmetatable(EWaveParent,	{__index = Enemy})
--------------------------------------------------------

