EGhost = {
	draw = function(self)
		local vx = self.velocity.x
		if vx==0 then
			graphics.thisstage.ghostM:drawAt(self.position)
		elseif vx<0 then
			graphics.thisstage.ghostL:drawAt(self.position)
		else
			graphics.thisstage.ghostR:drawAt(self.position)
		end
	end;
}

----------------------------------------------------------------------------------------
E_Explosion = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 150
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self:move(20)
		wait(10)
		nwayBToPlayer(self.position,size.ballL,4,30,5,0,graphics.ballL[2])
	end;
}
----------------------------------------------------------------------------------------
EBully1 = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 100
		self.group = Object.ENEMY
	end;
	routine= function(self)
		self:move(math.random(30,60))
		for i=1,3 do
			if self.position.y>screen.h/2 then
				self:bend(30,20)
			elseif self.position.y<=screen.h/2 then
				self:bend(-30,20)
			end
			nwayBToPlayer(self.position,size.ballM,2,2,5,0,graphics.ballM[2])
			self:move(10)
		end
		self:move(15)
		nwayBToPlayer(self.position,size.ballM,2,3,8,0,graphics.ballM[2])
		self:move(20)
		nwayBToPlayer(self.position,size.ballM,2,3,8,0,graphics.ballM[2])
		self:move(-1)
	end;
}
----------------------------------------------------------------------------------------
ESwarm1 = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 80
		self.group = Object.ENEMY
	end;
	routine = function(self)
		wait(self.delay)
		self:move(25)
		for i=1,3 do
			self:move(15)
			if i%2==1 then
				nwayBDirSpeed(self.position,size.ballM,180,3,3,5,0,graphics.ballM[8])
			else
				nwayBToPlayer(self.position,size.ballM,2,3,5,0,graphics.ballM[9])
			end
			self:move(5)
		end
		self:move(-1)
	end
}
ESwarm2 = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 80
		self.group = Object.ENEMY
	end;
	routine = function(self)
		wait(self.delay)
		self:move(25)
		for i=1,3 do
			self:move(15)
			if i%2==1 then
				nwayBDirSpeed(self.position,size.ballM,180,3,3,5,0,graphics.ballM[8])
			else
				nwayBToPlayer(self.position,size.ballM,2,3,5,0,graphics.ballM[9])
			end
			if self.position.y<screen.h/2 then
				self:bend(-30,5)
			end
			if self.position.y>screen.h/2 then
				self:bend(30,5)
			end
		end
		self:move(-1)
	end;
}

------------------------------------------------------------------------------------------
ERandomBend = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 90
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.group = Object.ENEMY
		self:move(30)
		for i=1,3 do
			nway(self.position,vector.new(-3,0),4,6,i,EBend)
		end
		wait(60)
		if self.position.y>screen.h/2 then
			self.velocity = vector.new(0,-10)
		end
		if self.position.y<screen.h/2 then
			self.velocity = vector.new(0,10)
		end
		self:move(-1)
	end;
}
EBend = {
	initialize = function(self)
		self.frame.w = 15
		self.frame.h = 15
		self.score = 50
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self.score = 30
		self.frame.w = 15
		self.frame.h = 15
		self.group = Object.ENEMY
		self:move(15)
		for i=1,4 do
			self:bend(math.random(-50,50),20)
			self:accelerate(math.random(-0.5,1))
		end
		self:move(-1)
	end;
	draw = function(self)
		graphics.ballM[1]:drawAt(self.position)
	end;
}

---------------------------------------------------------------------------------------------------
ERiot = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 100
		self.itime = 0
		self.itime_init = 180
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self:setMovePosition02(vector.new(screen.w-100,screen.h/2),100)
		for i=1,13 do
			nwayBDirSpeed(self.position,size.ballL,130+9*i,3,10,10,0,graphics.ballL[9])
			self:pause(5)
		end
		self:pause(150)
		for i=1,13 do
			nwayBDirSpeed(self.position,size.ballL,230-9*i,3,10,10,0,graphics.ballL[9])
			self:pause(5)
		end
		self:pause(200)
		for i=1,26 do
			if i<=13 then
				nwayBDirSpeed(self.position,size.ballL,110+12*i,3.5,10,10,0,graphics.ballL[9])
			end
			if i>13 then
				nwayBDirSpeed(self.position,size.ballL,266-12*(i-13),3.5,10,10,0,graphics.ballL[9])
			end
			self:pause(8)
		end
		self:pause(250)
		for i=1,10 do
			nwayBToPlayer(self.position,size.ballL,3,8+i,10,0,graphics.ballL[8])
			self:pause(7)
		end
		self:pause(200)
		for i=1,4 do
			if i<=2 then
				nwayToPlayer(self.position,3.5,2,20,0,EStorm1)
			end
			if i>2 then
				nwayToPlayer(self.position,3.5,3,20,0,EStorm1)
			end
			self:moveToPlayer(vector.new(0,150),100,screen.w/2+150,30,screen.w-50,screen.h-30)
			self:pause(400)	
		end
		self:setMovePosition02(vector.new(screen.w-100,screen.h/2),50)
		createShot(vector.new(screen.w/2,screen.h/2),vector.new(0,0),0,EArrow2)
		self:pause(300)
		for i=1,3 do
			createShot(vector.new(screen.w/2+math.random(-10,10),screen.h/2+math.random(-10,10)),vector.new(-3,0),0,EStorm2)
		end
		self:pause(200)
		self.velocity = vector.new(3,5)
		self:move(-1)	
	end;
	draw = function(self)
		if self.itime%6 > 0 then return end
		local vx = self.velocity.x
		if vx==0 then
			graphics.thisstage.ghostM:drawAt(self.position)
		elseif vx<0 then
			graphics.thisstage.ghostL:drawAt(self.position)
		else
			graphics.thisstage.ghostR:drawAt(self.position)
		end
	end;
}
EArrow2 = {
	initialize = function(self)
		self.frame.w = 0
		self.frame.h = 0
		self.score = 100
		self.group = Object.ENEMY
	end;
	routine = function(self)
		wait(50)
		for i=1,4 do
			nwayBDirSpeed(self.position,size.ballL,180+i*3,3,36,10,0,graphics.ballL[4])
			wait(10)
		end
	end;
}
EStorm1 = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 100
		self.itime = 0
		self.itime_init = 180
		self.hp = 3
		self.group = Object.ENEMY
		self.graphic = graphics.thisstage.mouthclosed
	end;
	routine = function(self)
		r = 10
		self:move(80)
		self.graphic = graphics.thisstage.mouth
		for i=1,204 do
			self.velocity = self.velocity:rotate(r)
			if i%6==0 then
				nwayB(self.position, self.velocity, size.ballS, 3, 20, 1, graphics.ballS[4])
			end
			self:move(2)
			r = r+1
		end
		self:move(-1)
	end;
}
EStorm2 = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 100
		self.itime = 0
		self.itime_init = 180
		self.hp = 4
		self.group = Object.ENEMY
		self.graphic = graphics.thisstage.mouth
	end;
	routine = function(self)
		r = 10
		for i=1,204 do
			self.velocity = self.velocity:rotate(r)
			if i%6==0 then
				nwayB(self.position, self.velocity, size.ballS, 3, 20, 1, graphics.ballS[4])
			end;
			self:move(3)
			r = r+1
		end
		self:move(-1)
	end;
}

-------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
Empty = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 100
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self:move(10)
		for i=1,4 do
			if self.position.y<screen.h/2 then
				nwayBDirSpeed(self.position,size.ballM,90+i*8,3,18,10,0,graphics.ballM[9])
			end
			if self.position.y>screen.h/2 then
				nwayBDirSpeed(self.position,size.ballM,270-i*8,3,18,10,0,graphics.ballM[9])
			end
			wait(8)
		end
		self.velocity = vector.new(100,0)
		self:move(-1)
	end
}

----------------------------------------------------------------------------------------
EWander = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 100
		self.group = Object.ENEMY
	end;
	routine = function(self)
		self:move(20)
		for i=1,30 do
			self:randomMove(3,3,10)
			if i%6==0 then
				nwayBToPlayer(self.position,size.ballM,2,3,10,0,graphics.ballM[4])
			end
		end
		local a = math.random(0,1)
		if a<=0.5 then
			self.velocity = vector.new(0,10)
		else
			self.velocity = vector.new(0,-10)
		end
		self:move(-1)
	end;
}

-------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------

ESizune = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.itime = 0
		self.group = Object.ENEMY_SHIELD
	end;
	routine = function(self)
		self.followers = nwayDirSpeed(self.position+vector.new(0,120),180,5,1,90,0,EBossEye)
		self.followers.routine = function(self) self:bend(30000,12560) end
		self:accelerateGradually(-2,150)
		repeat self:levitate(1) until bossbattle_start

		self:setMovePosition02(vector.new(screen.w-100,screen.h/2),150)
		self:setMovePosition02(vector.new(screen.w-200,screen.h/4),150)
		self.velocity = vector.new(-2,0)
		createShot(vector.new(screen.w/4*3+100,100),vector.new(0,0),0,EArrow3)
		createShot(vector.new(screen.w/4*3+100,screen.h-100),vector.new(0,0),0,EArrow3)
		for i=1,3 do
			self:bend(-90,70)
			wait(50)
			self:bend(-90,70)
			self:bend(90,70)
			wait(50)
			self:bend(180,140)
			self:bend(90,70)
			wait(50)
			if i<3 then
			self:bend(-90,70)
			self:bend(-90,70)
			wait(50)
			end
		end
		self:setMovePosition02(vector.new(screen.w-100,screen.h/2),80)
		wait(200)
		for i=1,7 do
			nwayBToPlayer(self.position, size.ballM, 51, 21-i, 10, 0, graphics.ballM[7]):move(1):accelerate(-50+i*0.8)
		end
		wait(300)
		for i=1,4 do
			createShot(self.position,vector.new(-5*i,0),0,EPrison)
		end
		wait(100)
		for i=1,13 do
			self:moveToPlayer(vector.new(math.random(-40,40),100),70,screen.w/2+150,30,screen.w-50,screen.h-30)
			wait(30)
		end
		self:setMovePosition02(vector.new(screen.w-50,screen.h/2),50)
		wait(200);
		for i=1,7 do
			nwayBToPlayer(self.position,size.ballM,51,21-i,10,10,graphics.ballM[7]):move(1):accelerate(-50+i*0.8)
		end
		wait(300)
		for i=1,10 do
			wait(100)
			self:moveToPlayer(vector.new(0,150),100,screen.w/2+150,30,screen.w-50,screen.h-30)
		end;
		self:setMovePosition02(vector.new(screen.w-100,screen.h/2),150)

		repeat self:levitate(1) until lastboss
		repeat self:levitate(1) until lastboss.hp==0
		self.velocity = vector.new(4,4)
		self:move(-1)
	end;
}
EArrow3 = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.itime = 0
		self.itime_init = 120
		self.hp = 3
		self.score = 250
		self.group = Object.ENEMY
		self.graphic = graphics.thisstage.ghostM
	end;
	routine = function(self)
		wait(50)
		for i=1,35 do
			nwayBToPlayer(self.position,size.ballM,4,1,5,0,graphics.ballM[7])
			wait(50)
		end
	end;
}
EPrison = {
	initialize = function(self)
		self.frame.w = 3
		self.frame.h = 3
		self.group = Object.NONE
	end;
	routine= function(self)
		wait(30)
		if self.velocity.x==-20 then		--E
			self:setMovePosition02(vector.new(screen.w-80,screen.h-50),50)
		elseif self.velocity.x==-15 then	--
			self:setMovePosition02(vector.new(80,screen.h-50),50)
		elseif self.velocity.x==-5 then		--
			self:setMovePosition02(vector.new(80,50),50)
		elseif self.velocity.x==-10 then	--E
			self:setMovePosition02(vector.new(screen.w-80,50),50)
		end
		local theta
		wait(50)
		if self.position.x>screen.w/2 and self.position.y>screen.h/2 then			--E
			theta = 235
		elseif self.position.x<=screen.w/2 and self.position.y>screen.h/2 then		--
			theta = 305
		elseif self.position.x<=screen.w/2 and self.position.y<=screen.h/2 then		--
			theta = 55
		else																		--E
			theta = 125
		end
		for i=1,48 do
			nwayBDirSpeed(self.position,vector.new(10,10),theta,5,2,90,0,graphics.ballS[1])
			wait(25)
		end
	   self:delete() 
	end;
}
-----------------------------------------------------------------------------------------------------------

EBossEye = {
	initialize = function(self)
		self.frame.w = 40
		self.frame.h = 40
		self.score = 200
		self.itime = 0
		self.itime_init = 120
		self.group = Object.ENEMY_SHIELD
		self.score = 200
	end;
	routine = function(self)
		repeat self:move(200) until bossbattle_start
---[[
		self:move(175)
		for i=1,24 do
			self:move(82)
			for i=1,2 do
				local b = createBullet(self.position, vector.new(math.random(-6,-4), math.random(-2,2)):lengthen(7), size.ballL, 0, graphics.ballL[3])
				b.routine = function(self)
					for i=1,7 do
						createBullet(self.position, self.velocity:lengthen(4), vector.new(16,16), 0, graphics.ballM[2])
						self:move(15)
					end
					self:move(-1)
				end
			end
		end
		self:move(850)
		for i=1,18 do
			self:move(50)
			nwayBToPlayer(self.position,size.ballM,3,8,8,0,graphics.ballM[7])
			self:move(22)
		end
		self:move(650)
		for i=1,12 do
			for j=1,3 do
				createShot(self.position,vector.new(-4,0),0,EArrow4)
			end;
			self:move(163)
		end
		self:move(300)
--]]
		lastboss = createShot(self.position, vector.new(-1,0), 0, EEyeGather)
	end;
	draw = function(self)
		if self.itime%6 > 0 then return end
		local v = (player.position - self.position):rotate(45)
		local q = quadrant(v, vector.new(0,0))
		if q==1 then
			graphics.eye[4]:drawAt(self.position)
		elseif q==2 then
			graphics.eye[2]:drawAt(self.position)
		elseif q==3 then
			graphics.eye[5]:drawAt(self.position)
		else
			graphics.eye[3]:drawAt(self.position)
		end
	end;
}
EArrow4 = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 90
		self.group = Object.ENEMY
	end;
	routine = function(self)
		for i=1,3 do
			self:bend(math.random(-40,40),20)
			nwayBToPlayer(self.position,size.ballM,2,3+(-1)^i,15,5,graphics.ballM[3])
			self:move(20)
		end
		self:move(-1)
	end;
	draw = function(self)
		graphics.ballL[2]:drawAt(self.position)
	end;
}

EEye = {
	draw = function(self)
		local v = (player.position - self.position):rotate(45)
		local q = quadrant(v, vector.new(0,0))
		if q==1 then
			graphics.eye[4]:drawAt(self.position)
		elseif q==2 then
			graphics.eye[2]:drawAt(self.position)
		elseif q==3 then
			graphics.eye[5]:drawAt(self.position)
		else
			graphics.eye[3]:drawAt(self.position)
		end
	end;
}
EEyeGather = {
	initialize = function(self)
		self.frame.w = 30
		self.frame.h = 30
		self.score = 100
		self.itime = 0
		self.itime_init = 150
		self.hp = 4
		self.group = Object.ENEMY_SHIELD
	end;
	routine = function(self)
		self:move(120)
		local f1 = Group.new()
		local f2 = Group.new()
		local f3 = Group.new()
		local f4 = Group.new()
		for i =1,31 do
			f1:add(createShot(vector.new(30*i,-14),vector.new(0,math.random(0,300)/1000),0,EEye))
			f2:add(createShot(vector.new(30*i,screen.h+14),vector.new(0,-math.random(0,300)/1000),0,EEye))
		end;
		for i =1,18 do
			f3:add(createShot(vector.new(-14,30*i),vector.new(math.random(0,300)/1000,0),0,EEye))
			f4:add(createShot(vector.new(screen.w+14,30*i),vector.new(-math.random(0,300)/1000,0),0,EEye))
		end
		self:pause(200)
		while true do
			self:moveToPlayer(vector.new(150,100),60,0,0,screen.w,screen.h);

			for i=1,31 do
				f1.members[i]:gather(self.position+vector.new(math.random(-250,250),math.random(-250,250)),2)
				f2.members[i]:gather(self.position+vector.new(math.random(-250,250),math.random(-250,250)),2)
			end;
			for i=1,18 do
				f3.members[i]:gather(self.position+vector.new(math.random(-250,250),math.random(-250,250)),2)
				f4.members[i]:gather(self.position+vector.new(math.random(-250,250),math.random(-250,250)),2)
			end
			nwayBToPlayer(self.position,size.spindle,3,3,5,0,graphics.spindle[3])
			self:pause(60)
			nwayBToPlayer(self.position,size.spindle,3,3,5,0,graphics.spindle[3])
		end
	end;
	draw = function(self)
		if self.itime%6 > 0 then return end
		local v = (player.position - self.position):rotate(45)
		local q = quadrant(v, vector.new(0,0))
		if q==1 then
			graphics.eye[4]:drawAt(self.position)
		elseif q==2 then
			graphics.eye[2]:drawAt(self.position)
		elseif q==3 then
			graphics.eye[5]:drawAt(self.position)
		else
			graphics.eye[3]:drawAt(self.position)
		end
	end;
}

--------------------------------------------------------
--------------------------------------------------------
setmetatable(EGhost,	{__index = Enemy})
setmetatable(E_Explosion,	{__index = EGhost})
setmetatable(EBully1,	{__index = EGhost})
setmetatable(ESwarm1,	{__index = EGhost})
setmetatable(ESwarm2,	{__index = EGhost})
setmetatable(ERandomBend,	{__index = EGhost})
setmetatable(EBend,		{__index = Enemy})

setmetatable(ERiot,		{__index = EDurable})
setmetatable(EArrow2,	{__index = Enemy})
setmetatable(EStorm1,	{__index = EDurableHP})
setmetatable(EStorm2,	{__index = EDurableHP})

setmetatable(Empty,		{__index = Enemy})
setmetatable(EWander,	{__index = EGhost})

setmetatable(ESizune,	{__index = Sizune})
setmetatable(EPrison,	{__index = Enemy})
setmetatable(EArrow3,	{__index = EDurableHP})

setmetatable(EBossEye,	{__index = EDurable})
setmetatable(EArrow4,	{__index = Enemy})
setmetatable(EEye, {__index = EBullet})
setmetatable(EEyeGather, {__index = EDurableHP})
