Item = {
	routine = function(self)
		self:move()
	end;
	move = function(self)
		local yield = coroutine.yield
		while true do
			local v	= player.position - self.position
			local distance = v:length()
			if distance < self.radius then
				self.position = self.position + player.velocity + v/10
				self.soundflag = self.soundflag + 1
				if self.soundflag==1 then sound.item:play() end
			else
				self.position.x = self.position.x - 3
			end
			yield()
		end
		return self
	end;
}
Item1 = {
	initialize = function(self)
		self.radius = 150
		self.frame.w = 5
		self.frame.h = 5
		self.group = Object.ITEM
		self.soundflag = 0
	end;
	draw = function(self)
		graphics.item:drawAt(self.position)
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER then
			score = score + 10
			self:delete()
		end
	end;
}
Item2 = {
	initialize = function(self)
		self.radius = 150
		self.frame.w = 10
		self.frame.h = 10
		self.group = Object.ITEM
		self.soundflag = 0
	end;
	draw = function(self)
		graphics.item2:drawAt(self.position)
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER then
			score = score + 100
			self:delete()
		end
	end;
}
ItemCostUp = {
	initialize = function(self)
		self.radius = 200
		self.frame.w = 10
		self.frame.h = 10
		self.group = Object.ITEM
		self.soundflag = 0
	end;
	draw = function(self)
		graphics.drawLineBox(self.frame, 255,255,255)
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER then
			event.addShotCost(5,20)
			self:delete()
		end
	end;
}
ItemCostDown = {
	initialize = function(self)
		self.radius = 150
		self.frame.w = 10
		self.frame.h = 10
		self.group = Object.ITEM
		self.soundflag = 0
	end;
	draw = function(self)
		graphics.drawLineBox(self.frame, 255,255,255)
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER then
			event.addShotCost(-5,-20)
			self:delete()
		end
	end;
}
function Enemy:dropItem()
	if self.score==nil then return end
	local q = math.floor(self.score/100)
	local r = self.score%100
	for i=1,q do
		createShot(self.position+vector.new(math.random(-50,50),math.random(-50,50)), self.velocity, 0, Item2)
	end
	q = math.floor(r/10)
	for i=1,q do
		if math.random(0,9)<5 then
			createShot(self.position+vector.new(math.random(-50,50),math.random(-50,50)), self.velocity, 0, Item1)
		end
	end
--[[
	--1̈ʂ10_ACẽhbvw肵AҒlI1̈ʂ܂œ_߂悤ɂB
	for i=1,q do
		createShot(self.position+vector.new(math.random(-50,50),math.random(-50,50)), self.velocity, 0, Item2)
	end
	q = math.floor(r/10)
	r = r%10
	for i=1,q+1 do
		if math.random(0,9)<r then
			createShot(self.position+vector.new(math.random(-50,50),math.random(-50,50)), self.velocity, 0, Item1)
		end
	end
--]]
end

setmetatable(Item,		{__index = Object})
setmetatable(Item1,		{__index = Item})
setmetatable(Item2,		{__index = Item})
setmetatable(ItemCostUp,	{__index = Item})
setmetatable(ItemCostDown,	{__index = Item})


