--------------------------------------------------------------
-- Constants for Grouping ------------------------------------
--------------------------------------------------------------

Object.NONE = 0
Object.PLAYER = 1
Object.PLAYER_BULLET = 2
Object.ENEMY = 11
Object.ENEMY_SHIELD = 12
Object.ITEM =21

--------------------------------------------------------------
--[[ O֐
--------------------------------------------------------------
oƂẮAԂ^]悤ȊŋO𑀍삵ĂB
selfłB
--------------------------------------------------------------]]
function Object:move(frame)
	local yield = coroutine.yield
	if frame == -1 then
		while true do
			self.position = self.position + self.velocity
			yield()
		end
	end
	for i=1,frame do
		self.position = self.position + self.velocity
		yield()
	end
	return self
end
function Object:accelerate(acceleration)
	if self.velocity:length()+acceleration < 0 then
		self.velocity = vector.new(0,0)
	else
		self.velocity:setLength(self.velocity:length() + acceleration)
	end
	return self
end
function Object:accelerateGradually(acceleration, frame)
	local acceleration_per_frame = acceleration / frame
	for i=1,frame do
		self:accelerate(acceleration_per_frame)
		self:move(1)
	end
	return self
end
function Object:rotate(angle)
	self.velocity = self.velocity:rotate(angle)
	return self
end
function Object:bend(angle, frame)
	local angular_velocity = angle / frame
	for i=1,frame do
		self:rotate(angular_velocity)
		self:move(1)
	end
	return self
end
function Object:pause(frame)
	local v = self.velocity
	self.velocity = vector.new(0,0)
	self:move(frame)
	self.velocity = v
	return self
end
function Object:gather(target,speed)
	local v = target - self.position
	self.velocity = v:lengthen(speed)
	return self
end
function Object:accelebend(angle, acceleration, frame)
	local angular_velocity = angle / frame
	local acceleration_per_frame = acceleration / frame
	for i=1,frame do
		self:rotate(angular_velocity)
		self:accelerate(acceleration_per_frame)
		self:move(1)
	end
	return self
end
------------------------------------------------------
--[[ ړn֐
------------------------------------------------------
قƂǂ΍Ww肵܂Bړn֐͌yXgȂŁA
ȂׂOłȂƂĂB
------------------------------------------------------]]
--w肵xNgŁAݒ肵t[ړ
function Object:vectorMove(velocity, frame)
	local v = self.velocity
	self.velocity = velocity
	self:move(frame)
	self.velocity = v
	return self
end
--w肵W(target)ցAݒ肵ňړ
--ړĂȂƂ(target = self.position)̓oOɂȂ邩H
function Object:setMovePosition01(target,speed)
	local v = target - self.position
	local frame = v:length() / speed
	v:setLength(speed)
	self:vectorMove(v,frame)
	return self
end
--w肵WցAݒ肵t[ňړ
function Object:setMovePosition02(target, frame)
	self:vectorMove((target - self.position) / frame, frame)
	return self
end
--w肵WցBd݂̂ړ
--m		: ʁB̎Őݒ(0<m<1:,1<m:)
--v0	: 
function Object:setMovePosition03(target,m,v0)
	local v = target - self.position
	local distance = v:length()
	--萔p͈ړɂȂ悤ɒ́BIɂmɂĒPł΂Ȃł悢B
	local p = 2/m
	--t[4Ƃ̊et[̑傫
	local framepart = distance / v0 / (p*p*p + p*p + p + 1)
	v:setLength(v0)
	self:vectorMove(v, framepart)
	self:vectorMove(p*v, framepart)
	self:vectorMove(p*p*v, framepart)
	self:vectorMove(p*p*p*v, framepart)
	return self
end
--vMove͈ړxNgBframe͈ړɂt[Bleftȉ͉͈͂
function Object:moveToPlayer(vMove, frame, left, top, right, bottom)
	local v
	local q = quadrant(self.position, player.position)
	if q == 1 then			--G猩ăvC[یɂƂ
		v = vMove
	elseif q == 2 then		--یɂƂ
		v = vMove:fliplr()
	elseif q == 3 then		--Oی
		v = -vMove
	else					--lی
		v = vMove:flipud()
	end

	--ړƔ͈͊OɏoȂ炻ɐÎ~
	if not inFrame(self.position + v, left, top ,right, bottom) then
		v = vector.new(0,0)
	end

	--ړv
	self:vectorMove(v / frame, frame)
end
function Object:randomMove(maxX, maxY, frame)
	local v = vector.new(math.random(-maxX, maxX), math.random(-maxY, maxY))
	self:vectorMove(v, frame)
end
function Object:levitate(time)
	local velocity = self.velocity
	if time==-1 then
		while true do
			self.velocity = vector.new(0, 0.2)
			self:move(50)
			self.velocity = vector.new(0, -0.2)
			self:move(100)
			self.velocity = vector.new(0, 0.2)
			self:move(50)
		end
	end
	for i=1,time do
		self.velocity = vector.new(0, 0.2)
		self:move(50)
		self.velocity = vector.new(0, -0.2)
		self:move(100)
		self.velocity = vector.new(0, 0.2)
		self:move(50)
	end
	self.velocity = velocity
	return self
end

----------------------------------------------------------------------------
----------------------------------------------------------------------------
Enemy = {
	draw = function(self)
		graphics.drawLineBox(self.frame, 255,255,255)
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER_BULLET then
			createShot(self.position, vector.new(0,0), 0, Explosion)
			self:dropItem()
			self:delete()
		elseif obj.group == Object.PLAYER then
			self:delete()
		end
	end;
}
EBullet = {
	initialize = function(self)
		self.group = Object.ENEMY
		self.score = 10
	end;
	routine = function(self)
		wait(self.delay)
		self:move(-1)
	end;
	draw = function(self)
		self.graphic:drawRotatedAt(self.position, math.atan2(self.velocity.y, self.velocity.x))
--		graphics.drawLineBox(self.frame, 0,0,0)--傫`FbNp
	end;
	hit = function(self, obj)
		if obj.group == Object.PLAYER_BULLET then
			createShot(self.position, vector.new(0,0), 0, ExplosionB)
			self:dropItem()
			self:delete()
		elseif obj.group == Object.PLAYER then
			self:delete()
		end
	end;
}
----------------------------------------------------------------------------
EDurable = {
	initialize = function(self)
		self.itime = 0
		self.itime_init = 120
	end;
	draw = function(self)
		if self.itime%6 > 0 then return end
		self.graphic:drawAt(self.position)
--		graphics.drawLineBox(self.frame, 255, 255, 255)
	end;
	hit = function(self, obj)
		if self.itime>0 then return end
		if obj.group == Object.PLAYER_BULLET then
			createShot(self.position, vector.new(0,0), 0, Explosion)
			self:dropItem()
			self.itime = self.itime_init
		elseif obj.group == Object.PLAYER then
			self.itime = self.itime_init
		end
	end;
	move = function(self,frame)
		local yield = coroutine.yield
		if frame == -1 then
			while true do
				self.position = self.position + self.velocity
				if self.itime>0 then self.itime = self.itime - 1 end
				yield()
			end
		end
		for i=1,frame do
			self.position = self.position + self.velocity
			if self.itime>0 then self.itime = self.itime - 1 end
			yield()
		end
		return self
	end;
}
EDurableHP = {
	hit = function(self, obj)
		if self.itime>0 then return end
		if obj.group == Object.PLAYER_BULLET then
			createShot(self.position, vector.new(0,0), 0, Explosion)
			self.hp = self.hp - 1
			self.itime = 120
			if self.hp==0 then
				self:dropItem()
				self:delete()
			end
		elseif obj.group == Object.PLAYER then
			self.itime = 120
		end
	end;
}

EDFollowed = {
	move = function(self, frame)
		local yield = coroutine.yield
		if frame == -1 then
			while true do
				self.position = self.position + self.velocity
				self.followers:giveVelocity(self.velocity)
				if self.itime>0 then self.itime = self.itime - 1 end
				yield()
			end
		end
		for i=1,frame do
			self.position = self.position + self.velocity
			self.followers:giveVelocity(self.velocity)
			if self.itime>0 then self.itime = self.itime - 1 end
			yield()
		end
		return self
	end;
	remove = function(self)
		for i,bullets in ipairs(self.followers.members) do
			bullets:delete()
		end
	end;
	hit = function(self, obj)
		if self.itime>0 then return end
		if obj.group == Object.PLAYER_BULLET then
			createShot(self.position, vector.new(0,0), 0, Explosion)
			self.itime = itime_init
			self:delete()
			self:remove()
		elseif obj.group == Object.PLAYER then
			self.itime = itime_init
		end
	end;
}
EDFollowedHP = {
	hit = function(self, obj)
		if self.itime>0 then return end
		if obj.group == Object.PLAYER_BULLET then
			createShot(self.position, vector.new(0,0), 0, Explosion)
			self.itime = self.itime_init
			self.hp = self.hp - 1
			if self.hp==0 then
				self:dropItem()
				self:delete()
				self:remove()
			end
		elseif obj.group == Object.PLAYER then
			self.itime = self.itime_init
		end
	end;
}

----------------------------------------------------------------------------
----------------------------------------------------------------------------
Sizune = {
	draw = function(self)
		local x = player.position.x - self.position.x
		local vx = self.velocity.x
		if x>0 then
			if vx==0 then
				graphics.sizuneRM:drawAt(self.position)
			elseif vx<0 then
				graphics.sizuneRL:drawAt(self.position)
			else
				graphics.sizuneRR:drawAt(self.position)
			end
		else
			if vx==0 then
				graphics.sizuneLM:drawAt(self.position)
			elseif vx<0 then
				graphics.sizuneLL:drawAt(self.position)
			else
				graphics.sizuneLR:drawAt(self.position)
			end
		end
	end;
	hit = function(self, obj)
		if self.itime>0 then return end
   		if obj.group == Object.PLAYER_BULLET then
			nwayBToPlayer(vector.new(self.position.x-90,self.position.y+40),vector.new(22.4,22.4),4,7,10,0,graphics.ballM[9])
			nwayBToPlayer(vector.new(self.position.x-90,self.position.y-40),vector.new(22.4,22.4),4,7,10,0,graphics.ballM[9])
			self.itime=60
		elseif obj.group == Object.PLAYER then
			self.itime = 60
		end
	end;
	move = function(self, frame)
		yield = coroutine.yield
		if frame ==-1 then
			while true do
				self.position = self.position + self.velocity
				if self.followers then self.followers:giveVelocity(self.velocity) end
				if inFrame(player.position - self.position, -200, -150, 200, 150) and self.itime<0 then
					nwayBToPlayer(vector.new(self.position.x+80,self.position.y+70),vector.new(22.4,22.4),3,7,10,0,graphics.ballM[9])
					nwayBToPlayer(vector.new(self.position.x+80,self.position.y-70),vector.new(22.4,22.4),3,7,10,0,graphics.ballM[9])
					self.itime = 30
				end
				self.itime = self.itime - 1
				yield()
			end
		end
		for i=1,frame do
			self.position = self.position + self.velocity
			if self.followers then self.followers:giveVelocity(self.velocity) end
			if inFrame(player.position - self.position, -150, -100, 150, 100) and self.itime<0 then
				nwayBToPlayer(vector.new(self.position.x+80,self.position.y+70),vector.new(22.4,22.4),3,7,10,0,graphics.ballM[9])
				nwayBToPlayer(vector.new(self.position.x+80,self.position.y-70),vector.new(22.4,22.4),3,7,10,0,graphics.ballM[9])
				self.itime = 30
			end
			self.itime = self.itime - 1
			yield()
		end
		return self
	end;
}


----------------------------------------------------------------------------
----------------------------------------------------------------------------
Explosion = {
	routine = function(self)
		self.group = Object.NONE
		sound.explosion:play()
		wait(8)
	end;
	draw = function(self)
		graphics.explosion:drawAt(self.position)
	end;
}
--BBulleẗӖ
ExplosionB = {
	routine = function(self)
		self.group = Object.NONE
		sound.explosionb:play()
		wait(10)
	end;
	draw = function(self)
		graphics.explosionB:drawAt(self.position)
	end;
}

Image = {
	initialize = function(self)
		self.group = Object.NONE
	end;
	routine = function(self)
		self:move(-1)
	end;
	draw = function(self)
		self.graphic:drawAt(self.position)
	end;
}


----------------------------------------------------------------------------
----------------------------------------------------------------------------
setmetatable(Enemy,		{__index = Object})
setmetatable(EBullet,	{__index = Enemy})
setmetatable(EDurable,	{__index = Enemy})
setmetatable(EDurableHP,{__index = EDurable})
setmetatable(EDFollowed,	{__index = EDurable})
setmetatable(EDFollowedHP,	{__index = EDFollowed})
setmetatable(Sizune,	{__index = Object})
setmetatable(Explosion,	{__index = Object})
setmetatable(ExplosionB,{__index = Object})
setmetatable(Image,		{__index = Object})

