vector = {}

local function add(v1, v2) return vector.new(v1.x + v2.x, v1.y + v2.y) end
local function sub(v1, v2) return vector.new(v1.x - v2.x, v1.y - v2.y) end
local function mul(a, b)
	local i = tonumber(a)
	local v
	if i then
		v = b
	else
		i = tonumber(b)
		if i then v = a else return nil end
 	end
	return vector.new(v.x * i, v.y * i)
end
local function div(v, a)
	local d = tonumber(a)
	if d then
		return vector.new(v.x / d, v.y / d)
	else
		return nil
	end
end
local function unm(v) return vector.new(-v.x, -v.y) end

function vector.new(x, y)
	local v = {x = x, y = y}
	setmetatable(v, {
		__add = add;
		__sub = sub;
		__mul = mul;
		__div = div;
		__unm = unm;
		__index = vector;
	})
	return v
end

---------------------------------------------------------------------------------------------------



---------------------------------------------------------------------------------------------------
function vector:length()
	return math.sqrt(self.x * self.x + self.y * self.y)
end
function vector:setLength(len)
	local r = len / self:length()
	self.x = self.x * r
	self.y = self.y * r
end;
function vector:lengthen(len)
	local r = len / self:length()
	local x = self.x * r
	local y = self.y * r
	return vector.new(x, y)
end
function vector:rotate(angle)
	local rad = math.rad(angle)
	local x = math.cos(rad) * self.x - math.sin(rad) * self.y
	local y = math.sin(rad) * self.x + math.cos(rad) * self.y
	return vector.new(x, y)
end
function vector:fliplr()
	return vector.new(-self.x, self.y)
end
function vector:flipud()
	return vector.new(self.x, -self.y)
end


--[[


1.BKȕϐɑ܂傤B
v = vector.new(5, 19)

2.\bhg
v:length()			<= Ԃ܂B
v:setLength(1)			<= xNg̒Zbg܂B̏ꍇ͂PŁAPʃxNgɂȂ܂B
v2 = v:lengthen(30)		<= xNgw肵ɂVȃxNgԂ܂Blengthen(L΂)ƏĂ܂ʂɏk߂邱Ƃł܂B
v2 = v:rotate(30)		<= xNgw肵pxŉ]VȃxNgԂ܂Bpx͓xŎw肵܂B
v2 = v:fliplr()		<= E(LR)ЂԂxNgԂ܂
v2 = v:flipud()		<= ㉺(UD)ЂԂxNgԂ܂
]]